//////////////////////////////////////////////////////////////////////////////////////////////////////
//  NEB method for V(Ro,...,Rn)= sum -sin²(R_i)*exp(-(R_i)²)    PES                                 //
//                              i=0->n                                                              //
// with fixed ´alpha´ and ´k´ defined by the user(Steepest Descent Optimization)	            //
// for more information e-mail to: marm3.14@gmail.com                                               //
//												    //	
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include<iostream>
#include<cmath>
#include<iomanip>
#include<fstream>
#include"SEP.h"
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
using namespace std;
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Functions Declaration                                                                            //
//////////////////////////////////////////////////////////////////////////////////////////////////////
void fillingpoints(double **points,int dim,int images);
void tau(double **points,int dim,int images);
double norm(double *vec,int dim);
double scalar(double *vec,double *vec1,int dim);
void Minus_Grad_Perp(double ** points, int dim,int images);
void Fi_Parallel_and_Fi_Total(double ** points,int dim, int images,double k);
bool check(double **points,double &max,double accur,int dim, int images);
void move(double **points, int dim,int images,double alpha);
void maximum(double * pointTS,double ** points,int dim,int images,int &poss);
//////////////////////////////////////////////////////////////////////////////////////////////////////
//  Main Function                                                                                   //
//////////////////////////////////////////////////////////////////////////////////////////////////////
int main()
{ int i,j,l,dim,images,poss;
  bool prove;
  double k,alpha,accur,max;
  double ** points;
//////////////////////////////////////////////////////////////////////////////////////////////////////
  cout<<"Dimention of the  Surface(N):"<<endl;
  cin>>dim;
  cout<<"Number of Images[Io,...,In]:"<<endl;
  cin>>images;
  points=new double*[images];
    for(i=0;i<images;i++)
    {
     points[i]=new double[6*dim+1];
    }
  cout<<"Introduce the coordinates (Row 1 the reactant and"<<endl;
  cout<<"Row N for the product)"<<endl;
  cout<<"Image  Coordinates(x(0;1) x(0;2) x(0;3).....x(0;N))"<<endl;
  cout<<"                  (x(1;1) x(1;2) x(1;3).....x(1;N))"<<endl;
  cout<<"                       '      '     '         '    "<<endl;
  cout<<"                       '      '     '         '    "<<endl;
  cout<<"                       '      '     '         '    "<<endl;
  cout<<"                  (x(n;1) x(n;2) x(n;3).....x(n;N))"<<endl;
    for(i=0;i<images;i++)
    { for(j=0;j<dim;j++)
     {
      cin>>points[i][j];
     }
    }
  cout<<endl;
  cout<<"Value for k:"<<endl;
  cin>>k;
  cout<<"Value for alpha:"<<endl;
  cin>>alpha;
  cout<<"Accuracy(Ex. 0.00001):"<<endl;
  cin>>accur;
  cout<<endl;
//////////////////////////////////////////////////////////////////////////////////////////////////////
ofstream output;
output.open("Output.txt");
output<<"Dimention of the  Surface(N): "<<dim<<endl;
output<<fixed<<setprecision(5)<<"Value for k: "<<k<<endl;
output<<fixed<<setprecision(5)<<"Value for alpha: "<<alpha<<endl;
l=0;
prove=false;
do{
 fillingpoints(points,dim,images);
 tau(points,dim,images);
 Minus_Grad_Perp(points,dim,images);
 Fi_Parallel_and_Fi_Total(points,dim,images,k);
//////////////////////////////////////////////////////////////////////////////////////////////////////
output<<endl;
output<<"Iteration: "<<l<<endl;
output<<"     Coord.        V(R0...Rn)   Grad V()             tau              -Grad_Perp()  "<<endl;
 for(i=0;i<images;i++)
 {   output<<fixed;
    for(j=0;j<4*dim+1;j++)
    {
       output<<setprecision(5)<<points[i][j]<<"  ";
    }
    output<<endl;
 }
 output<<"     Fi_Parallel        Fi_Total"<<endl;
 for(i=0;i<images;i++)
 {   output<<fixed;
    for(j=4*dim+1;j<6*dim+1;j++)
    {
       output<<setprecision(5)<<points[i][j]<<"  ";
    }
    output<<endl;
 }
 prove=check(points,max,accur,dim,images);
 if(prove==false)
  {
    move(points,dim,images,alpha);
  }
  output<<"Maximum Value for |Fi|= ";
  output<<fixed<<setprecision(7)<<max<<" (NEB force module)"<<endl;
 l++;
}while((prove==false) && (l<10001));//+1 Because there is Iteration 0!
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Nearest point to TS (Coordinates,Gradiente and Hessian)                                          //
//////////////////////////////////////////////////////////////////////////////////////////////////////
  double ** hess;
  double * pointTS;
  double * grad;
  hess=new double*[dim];
  pointTS=new double[dim];
  grad=new double[dim];
  for(i=0;i<dim;i++)
   {hess[i]=new double[i];}
  SEP TS;
  TS.set_dim(dim);
  maximum(pointTS,points,dim,images,poss);
  output<<endl;
  output<<endl;
  output<<"The closest final value near the TS is the image: "<<poss+1<<endl;
  output<<fixed<<setprecision(5);
  for(i=0;i<dim;i++)
  {
    output<<points[poss][i]<<"   ";
  }
  output<<endl;
  output<<"Closest value near TS V(R1,R2,...,Rn): "<<fixed<<setprecision(5)<<TS.V(pointTS)<<endl;
  TS.gradient(pointTS,grad);
  output<<"Gradient(R1,R2,...,Rn):      (";
  for(i=0;i<(dim-1);i++)
   {output<<fixed<<setprecision(5)<<grad[i]<<";";}
   output<<fixed<<setprecision(5)<<grad[dim-1]<<") "<<endl;
  TS.hessian(pointTS,hess);
  output<<"Hessian(R1,R2,...,Rn):        ("<<fixed<<setprecision(5)<<hess[0][0];
  for(i=1;i<dim;i++)
    {output<<fixed<<setprecision(5)<<"       "<<hess[0][i];}output<<") "<<endl;
  for(j=1;j<dim;j++)
    {
     output<<"                              ("<<fixed<<setprecision(5)<<hess[j][0];
     for(i=1;i<dim;i++)
     {output<<fixed<<setprecision(5)<<"     "<<hess[j][i];}
     output<<") "<<endl;
    }
  output.close();
///////////////////////////////////////////////////////////////////////////////////////////////////////
  for(i=0;i<dim;i++)
  { delete[] points[i];
    delete[] hess[i];
  }
  delete[] points;
  delete[] hess;
  delete[] pointTS;
  delete[] grad;
///////////////////////////////////////////////////////////////////////////////////////////////////////
 return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
// Functions                                                                                         //
///////////////////////////////////////////////////////////////////////////////////////////////////////
void fillingpoints(double **points,int dim,int images)
{ int i,j;
  double * grad;
  double * point;//for sending to SEP.
  SEP VPES;
  grad=new double[dim];
  point=new double[dim];
  VPES.set_dim(dim);
 for(i=0;i<images;i++)
 {
  for(j=0;j<dim;j++) //0 to dim-1 points
   {
    point[j]=points[i][j];
   }
  points[i][dim]=VPES.V(point); //dim V(Ro,..Rn)
  VPES.gradient(point,grad);
  for(j=dim+1;j<2*dim+1;j++) //dim+1 to 2*dim gradients
   {
     points[i][j]=grad[j-dim-1];
   }
  }
  delete[] grad;
  delete[] point;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
void tau(double **points,int dim,int images)
{ int i,j;
  double sqnorm;
  double *aux;
  double *aux1;
  aux=new double[dim];
  aux1=new double[dim];
 for(i=1;i<images-1;i++)
 { for(j=0;j<dim;j++)
   {
    aux[j]=points[i][j]-points[i-1][j];
    aux1[j]=points[i+1][j]-points[i][j];
   }
  sqnorm=norm(aux,dim);
  for(j=0;j<dim;j++){aux[j]=aux[j]/sqnorm;}
  sqnorm=norm(aux1,dim);
  for(j=0;j<dim;j++){aux1[j]=aux1[j]/sqnorm;}
  for(j=0;j<dim;j++){aux[j]=aux[j]+aux1[j];}
  sqnorm=norm(aux,dim);
  for(j=0;j<dim;j++){aux[j]=aux[j]/sqnorm;}
  for(j=2*dim+1;j<3*dim+1;j++){points[i][j]=aux[j-2*dim-1];}
 }
  delete[] aux;
  delete[] aux1;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Minus_Grad_Perp(double ** points, int dim,int images)
{ int i,j;
  double * aux;
  double * aux1;
  double a;
  aux=new double[dim];
  aux1=new double[dim];
  for(i=1;i<images-1;i++)
  { for(j=0;j<dim;j++)
    {
      aux[j]=points[i][dim+1+j]; //Gradient
      aux1[j]=points[i][2*dim+1+j]; // tau
    }
    a=scalar(aux,aux1,dim);
    for(j=0;j<dim;j++)
    {aux1[j]=aux1[j]*a;}
    for(j=0;j<dim;j++)
    {aux[j]=aux1[j]-aux[j];//-grad perp
    }
    for(j=0;j<dim;j++)
    {
      points[i][j+3*dim+1]=aux[j];
    }
  }
  delete[] aux;
  delete[] aux1;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Fi_Parallel_and_Fi_Total(double ** points,int dim, int images,double k)
{int i,j;
 double dif;
 double * aux;
 double * aux1;
 aux=new double[dim];
 aux1=new double[dim];
 for(i=1;i<images-1;i++)
 { for(j=0;j<dim;j++)
   {
    aux[j]=points[i+1][j]-points[i][j];
    aux1[j]=points[i][j]-points[i-1][j];
   }
   dif=k*norm(aux,dim)-norm(aux1,dim);
   for(j=0;j<dim;j++)
   {
    points[i][4*dim+1+j]=dif*points[i][2*dim+1+j];
   }
   for(j=0;j<dim;j++)
   {
    points[i][5*dim+1+j]=points[i][4*dim+1+j]+points[i][3*dim+1+j];
   }
 }
 delete[] aux;
 delete[] aux1;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
 bool check(double **points,double &max,double accur,int dim, int images)
{ int i,j;
  bool rev;
  double eval;
  double * aux;
  aux=new double[dim];
  rev=false;
  for(i=1;i<images-1;i++)
  {for(j=0;j<dim;j++)
   {
    aux[j]=points[i][j+5*dim+1];
   }
   eval=norm(aux,dim);
   if(i==1)
   {
     max=eval;
     if(max>accur)
     {break;
     }
   }
   else
   {if(max<eval)
     { max=eval;
       if(max>accur)
       {break;
       }
     }
   }
  }
  if((i==(images-1)) && (max<accur)){rev=true;} // images-1 because i++ made it plus one else
  delete[] aux;
  return  rev;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
void move(double **points, int dim,int images,double alpha)
{ int i,j;
  for(i=1;i<images-1;i++)
  { for(j=0;j<dim;j++)
    {
      points[i][j]=points[i][j]+alpha*points[i][j+5*dim+1];
    }
  }
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
void maximum(double * pointTS,double ** points,int dim,int images,int &poss)
{ int i,j;
    double res,min;
    double *grad;
    grad=new double[dim];
    SEP TS;
    for(i=1;i<images-1;i++)
    {for(j=0;j<dim;j++)
      {
        pointTS[j]=points[i][j];
      }
      TS.gradient(pointTS,grad);
      res=norm(grad,dim);
      if(i==1){poss=i; min=res;}
      else
      {if(min>res)
        { min=res;
          poss=i;
        }
      }
    }
    for(j=0;j<dim;j++)
    {
      pointTS[j]=points[poss][j];
    }
  delete[] grad;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
double norm(double *vec,int dim)
{
  return sqrt(scalar(vec,vec,dim));
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
double scalar(double *vec,double *vec1,int dim)
{ int i;
  double res;
  res=0.0;
   for(i=0;i<dim;i++)
   {
      res=res+vec[i]*vec1[i];
   }
  return res;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
