#include<iostream>
#include"SEP.h"
#include<cmath>
using namespace std;

SEP::SEP ()
{
  dim=2;
}

void SEP::set_dim(int a)
{
  dim=a;
}

SEP::~SEP ()
{
  //Only the Pointers to delete
}

double SEP::V(double * point)
{ int i;
  double res;
  res=0;
  for(i=0;i<dim;i++)
  {
      res=res-sin(point[i])*sin(point[i])*exp(-(point[i]*point[i]));
  }
  return res;
}

void SEP::gradient(double * point,double * grad)
{ int i;
   for(i=0;i<dim;i++)
   {
         grad[i]=2*(exp(-(point[i]*point[i])))*sin(point[i])*(point[i]*sin(point[i])-cos(point[i]));
   }
}

void SEP::hessian(double * point, double ** hessian)
{ int i,j;
  for(i=0;i<dim;i++)
   { for(j=0;j<dim;j++)
     {
       hessian[i][j]=0;
       if(i==j)
       {
         hessian[i][j]=exp(-(point[i]*point[i]))*(-4.0*(point[i]*point[i]-1.0)*sin(point[i])*sin(point[i])-2*cos(point[i])*cos(point[i])+8.0*point[i]*sin(point[i])*cos(point[i]) );
       }
     }
   }
}
